#include "Manager.h"


#define  SEVERER_IP "192.168.59.238"
#define  SERVER_PORT 9000

#include <stdlib.h>
#include <stdio.h>
#include <time.h>

CManager::CManager()
{
	m_bInit = 0;
	int ret = CreateEventEx(m_hDisEvent, FALSE, FALSE);
	if (ret < 0)
	{
		//throw 0xFFFFFFFF;
	}

	ret = CreateEventEx(m_hExitThread, TRUE, FALSE);
	if (ret < 0)
	{
		//throw 0xFFFFFFFF;
	}
	ret = CreateEventEx(m_hPushData,TRUE,FALSE);
	if (ret < 0)
	{
		//throw 0xFFFFFFFF;
	}
	memset(m_mac,0,32);
	m_nKeepLifeTime = 60*1000;
#ifdef WIN32
	WSADATA wsa = {0};
	int nRet = WSAStartup(MAKEWORD(2,2), &wsa);
	if (nRet != 0)
	{

	}
#endif

}

CManager::~CManager()
{
	CloseEventEx(m_hDisEvent);
	CloseEventEx(m_hExitThread);
#ifdef WIN32
	if (WSACleanup() == SOCKET_ERROR)
	{
		
	}
#endif
}

/*
	==JSonַҪȫٶȺjson 
	==type Ϊ1 ַ
*/
static int get_string_value(const char *str,const char * item,char *value,bool type=0)
{
	const char *pStart = NULL, *pEnd = NULL;
	if ((NULL == str) || (NULL == item) || (NULL == value))
		return -1;
	pStart = strstr(str,item);
	if (pStart == NULL)
		return -1;
	pStart += strlen(item);
	do{
		pStart++;
	}while(*pStart != ':');	///Ҫ滻ʼλ

	do{
		pStart++;
	}while(*pStart == ' '); 	///ոҪ
	pEnd = pStart;

	do{
		pEnd++;
	}while((*pEnd != ',') && (*pEnd != '}'));///Ҫ滻Ľλ


	if (type)
	{
		strncpy(value,pStart+1,(pEnd-pStart-2));
	}
	else
	{
		strncpy(value,pStart,(pEnd-pStart));
	}
	
	return 0;
}


void* WINAPI RoutineThreadProc(LPVOID lpParam)
{
	CManager* pThis = (CManager*)lpParam;
	if (!pThis)
	{
		return (void*)0xFFFFFFFF;
	}
	char buffer[32*1024] = {0};
	bool bExit = false;
	while(!bExit)
	{
		if (pThis->m_pSocket == 0)
		{
			Sleep(5);
			continue;
		}
		int nRect = recv(pThis->m_pSocket,buffer,32*1024,0);
		if (nRect>= MSG_HEAD_LEN)
		{
			DVRIP_MSG_HEAD_T head;
			memcpy(&head, buffer, MSG_HEAD_LEN);

			//0xFFͷı־
			if ( 0xFF == head.HeadFlag )
			{
				switch(head.MsgId)
				{
				case KEEPALIVE_RSP:
					{
						pThis->m_dwLastHeartBeatTime = GetTickCountEx();
					}
					break;
				case PUSH_DATA_RSQ:
					{
						SDK_ALARM_INFO alarmInfo;
						//ʱ
						char temptime[30] = {0};
		
						get_string_value(buffer+MSG_HEAD_LEN,"\"tm\"",temptime);
						time_t tmptm = strtol(temptime,0, 10);
						struct tm *local;
						local=localtime(&tmptm);
						alarmInfo.SysTime.year = local->tm_year;
						alarmInfo.SysTime.day = local->tm_mday;
						alarmInfo.SysTime.month = local->tm_mon;
						alarmInfo.SysTime.hour = local->tm_hour;
						alarmInfo.SysTime.minute = local->tm_min;
						alarmInfo.SysTime.second = local->tm_sec;
						alarmInfo.SysTime.isdst = local->tm_isdst;
						//õ豸
						char tempInt[10] = {0};

						get_string_value(buffer+MSG_HEAD_LEN,"\"type\"",tempInt);
						alarmInfo.iEvent = strtol(tempInt, 0, 10);
						char tempStatus[10] = {0};
						get_string_value(buffer+MSG_HEAD_LEN,"\"sub\"",tempStatus);
						alarmInfo.iStatus = strtol(tempStatus, 0, 10);
						char tempChan[10] = {0};
						get_string_value(buffer+MSG_HEAD_LEN,"\"chan\"",tempChan);
						alarmInfo.nChannel = strtol(tempChan, 0, 10);

						if (pThis->m_pfMessCallBack)
						{
							pThis->m_pfMessCallBack((char *)&alarmInfo,sizeof(SDK_ALARM_INFO),pThis->m_dwMessCallBack);
						}
						pThis->m_dwLastHeartBeatTime = GetTickCountEx();
					}
					break;
				}
			}
		}
		else
		{
			Sleep(5);
		}
		
		}


	return 0;
}

void* WINAPI HeatBeatThreadProc(LPVOID lpParam)
{
	CManager* pThis = (CManager*)lpParam;
	if (pThis == NULL)
	{
		return (void*)0xFFFFFFFF;
	}

	BOOL bSignal = TRUE;

	while (TRUE)
	{
		DWORD dwRet = WaitForSingleObjectEx(pThis->m_hExitThread, 30*1000);
		if (WAIT_OBJECT_0 == dwRet)
		{
			break;
		}
		
		unsigned char buf[1024] = {0};
		DVRIP_MSG_HEAD_T msg_head;
		msg_head.Version = MSG_VERSION;
		msg_head.HeadFlag = MSG_HEADFLAG;
		msg_head.MsgId = KEEPALIVE_REQ;
		msg_head.SID = pThis->m_SID;

		memcpy(buf,&msg_head,sizeof(DVRIP_MSG_HEAD_T));


		if(send(pThis->m_pSocket,(char *)buf,sizeof(DVRIP_MSG_HEAD_T),0) == SOCKET_ERROR )//ʧ
		{
			pThis->m_bOnLine = false;
			closesocket(pThis->m_pSocket);
		}

	}


	return 0;
}

void* WINAPI DealHeatProc(LPVOID lpParam)
{
	CManager* pThis = (CManager*)lpParam;
	if (pThis == NULL)
	{
		return (void*)0xFFFFFFFF;
	}

	BOOL bSignal = TRUE;

	while (TRUE)
	{
		DWORD dwRet = WaitForSingleObjectEx(pThis->m_hExitThread, 500);
		if (WAIT_OBJECT_0 == dwRet)
		{
			break;
		}

		if (GetTickCountEx() - pThis->m_dwLastHeartBeatTime >= pThis->m_nKeepLifeTime || !pThis->m_bOnLine)
		{
			pThis->CleanNetwork();
			pThis->InitNetwork();
		}

	}
	return 0;
}

int CManager::Init( fMessCallBack cbDisConnect,PhoneInfo  phoneinfo, DWORD dwUser )
{
	int nRet = 0;
	m_pfMessCallBack		= cbDisConnect;
	m_dwMessCallBack	= dwUser;
	strcpy(m_mac,phoneinfo.mac);
	m_bOnLine = false;
	m_phoneType = phoneinfo.type;
	int initRet = InitNetwork();
	//ʼ
	if (initRet != PUSH_LAYER_SUCCESS)
	{
		return initRet;
	}

	DWORD dwThreadID;
	nRet = CreateThreadEx(m_hThread, 0, (LPTHREAD_START_ROUTINE)RoutineThreadProc, (void*)this, 0, &dwThreadID);
	if (nRet < 0)
	{
		
	}

	//heartbeet߳
	nRet = CreateThreadEx(m_hHeatBeatThread, 0, (LPTHREAD_START_ROUTINE)HeatBeatThreadProc, (void*)this, 0, &dwThreadID);
	if (nRet < 0)
	{
		
	}
	//m_hDealHeatThread
	nRet = CreateThreadEx(m_hDealHeatThread, 0, (LPTHREAD_START_ROUTINE)DealHeatProc, (void*)this, 0, &dwThreadID);
	m_bInit = true;
	
	return PUSH_LAYER_SUCCESS;
}



int CManager::Uninit()
{
	return 0;
}

int CManager::InitNetwork()
{
	//SOCKET pSocket;
	if((m_pSocket=socket(AF_INET,SOCK_STREAM,0)) == SOCKET_ERROR)
	{
		closesocket(m_pSocket);
		return PUSH_LAYER_SOCKET_ERROR;
	}

	char ip[260];
	if ( inet_addr( SEVERER_IP) == -1 )  //
	{
		//		
		struct hostent *host_ptr = NULL;
		struct in_addr addr;

		host_ptr = gethostbyname(SEVERER_IP);
		if( host_ptr == NULL )
		{
			closesocket(m_pSocket);
			return PUSH_LAYER_SOCKET_DOMAIN;
		}
		addr.s_addr= *( DWORD* )host_ptr->h_addr;
		strcpy(ip, inet_ntoa(addr));
	}else                                //IP
	{
		strcpy(ip,SEVERER_IP);
	}

	sockaddr_in ServerAddr;
	ServerAddr.sin_family=AF_INET;
	ServerAddr.sin_addr.s_addr=inet_addr(ip);
	ServerAddr.sin_port=htons(SERVER_PORT);

	if(connect(m_pSocket,(sockaddr*)&ServerAddr,sizeof(ServerAddr)) == SOCKET_ERROR)
	{
		closesocket(m_pSocket);
		return PUSH_LAYER_SOCKET_CONNECT;
	}
	

	unsigned char buf[1024] = {0};
	DVRIP_MSG_HEAD_T msg_head;
	msg_head.Version = MSG_VERSION;
	msg_head.HeadFlag = MSG_HEADFLAG;
	msg_head.MsgId = LOGIN_REQ;
	msg_head.SID = m_phoneType;
	
	memcpy(buf,&msg_head,sizeof(DVRIP_MSG_HEAD_T));

	memcpy(buf+sizeof(DVRIP_MSG_HEAD_T),m_mac,strlen(m_mac));
	if(send(m_pSocket,(char *)buf,sizeof(DVRIP_MSG_HEAD_T)+strlen(m_mac),0) == SOCKET_ERROR )//ʧ
	{
		closesocket(m_pSocket);
		return PUSH_LAYER_SOCKET_CONNECT;
	}

	
	//жݽʱʱ
	int sockfd = (int)m_pSocket;
	fd_set fdR;
	struct timeval timeout = {15,0};//selectȴ10룬Ҫ0 
	int nRet = -1;
	FD_ZERO(&fdR);
	FD_SET(sockfd,&fdR);
	switch(select(sockfd + 1, &fdR, NULL, NULL,&timeout))
	{
	case -1:                       //select
		nRet = PUSH_LAYER_BUSING_SELECT;
		break;
	case 0:                        //ʱ
		nRet = PUSH_LAYER_BUSING;
		break;
	default:
		if(FD_ISSET(sockfd,&fdR))  //Ƿ
		{
			int nRect=0;
			char buffer[29+MSG_HEAD_LEN] = { 0 };
			nRect = recv(m_pSocket,buffer,29+MSG_HEAD_LEN,0);
			if ( nRect <= 0 ||nRect <  MSG_HEAD_LEN)
			{	
				//ûյκݣ鷳
				closesocket(m_pSocket);
				return PUSH_LAYER_BUSING_RECVICE;
			}

			DVRIP_MSG_HEAD_T head;
			memcpy(&head, buffer, MSG_HEAD_LEN);

			//0xFFͷı־
			if ( 0xFF != head.HeadFlag )
			{
				closesocket(m_pSocket);
				return PUSH_LAYER_BUSING_RECVICE;
			}
			if (head.MsgId == LOGIN_RSP)
			{
				m_SID = head.SID;
				memcpy(m_uuid,buffer+ MSG_HEAD_LEN,29);
				m_bOnLine = true;
				return PUSH_LAYER_NOERROR;
			}
			 	
		}
	}

}

int CManager::LoginToServ()
{
	//char HttpHead[512] = {0};
//	std::string		m_strHttpHead;
	//char pReqBuf[1024*3] = {0};
	//time_t nowday;
	//nowday=time(NULL);
	//printf(ctime(&nowday));

		//long btime = ((long)nowday + 1970*24*3600 - 12*3600)*10;

		//char pBuf[128] = {0};
		//snprintf(pBuf, sizeof(pBuf),"Content-Type: multipart/form-data; boundary=----------------------------%x\r\n",btime);

		//snprintf(HttpHead, sizeof(HttpHead), "POST /rest/message/box/setup.json HTTP/1.1\r\n");
		//m_strHttpHead = HttpHead;
		//m_strHttpHead += "Host: push.umeye.cn\r\n";
		//
		//m_strHttpHead += "Accept: */*\r\n";
		//m_strHttpHead += "flat:xiongmai\r\n";
return 0;
	
}

int CManager::CleanNetwork()
{
	closesocket(m_pSocket);
	m_bOnLine = false;
	return 0;
}
