#ifndef _MANAGER_H_
#define _MANAGER_H_
#include "PushLayer.h"
#include "MsgDef.h"
#include "../Include/osIndependent.h "
#ifdef WIN32
#include "WinSock2.h"
#pragma comment(lib, "ws2_32.lib")
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif
class CManager
{
public:
	CManager();
	~CManager();
	int	Init(fMessCallBack cbDisConnect,PhoneInfo  phoneinfo, DWORD dwUser);
	int Uninit();

private:
	bool m_bInit;

	OS_THREAD					m_hThread;
	OS_THREAD					m_hHeatBeatThread;	//heartbee߳̾
	OS_THREAD					m_hDealHeatThread;	//heartbee߳̾
private:
	
	int LoginToServ();
public:
	SOCKET m_pSocket;
	OS_EVENT					m_hDisEvent;
	OS_EVENT					m_hExitThread;
	OS_EVENT					m_hPushData;
	char					m_mac[32];
	unsigned int					m_SID;
	char					m_uuid[30];
	int CleanNetwork();
	int InitNetwork();
	bool m_bOnLine;
	int m_phoneType;//ֻ
	unsigned int	m_nKeepLifeTime;						// 
	unsigned long	m_dwLastHeartBeatTime;					// һηʱ
	fMessCallBack	m_pfMessCallBack;		/*豸Ϣص */
	DWORD m_dwMessCallBack;

};

#endif
