/*
	==
	==
*/
#ifndef PUSH_LAYER_H
#define PUSH_LAYER_H
#ifdef WIN32

#define PUSH_LAYER_API  extern "C" __declspec(dllexport)

#ifndef CALL_METHOD
#define CALL_METHOD	__stdcall  //__cdecl
#endif

#else	//linux
#define PUSH_LAYER_API	extern "C"
#define CALL_METHOD
#define CALLBACK
#define WORD	unsigned short
#define DWORD	unsigned long
#define LPDWORD	DWORD*
#define BOOL	int
#define TRUE	1
#define FALSE	0
#define BYTE	unsigned char
#define LONG	long
#define UINT	unsigned int
#define HDC		void*
#define HWND	void*
#define LPVOID	void*
//#define NULL	0
#define LPCSTR  char*
#define LPCTSTR  const char*
#endif


#define 	PUSH_LAYER_NOERROR					0					//ûд
#define     PUSH_LAYER_SUCCESS					1					//سɹ
#define		PUSH_LAYER_SOCKET_ERROR				-1					//
#define     PUSH_LAYER_SOCKET_DOMAIN			-2 
#define     PUSH_LAYER_SOCKET_CONNECT			-3
#define     PUSH_LAYER_ERROR_Thread				-4
#define     PUSH_LAYER_BUSING                    -5
#define     PUSH_LAYER_BUSING_SELECT     -6
#define     PUSH_LAYER_BUSING_RECVICE -7 
/// ¼
enum SDK_EventCodeTypes
{
	SDK_EVENT_CODE_INIT = 0,
	SDK_EVENT_CODE_LOCAL_ALARM = 1,	//ر
	SDK_EVENT_CODE_VIDEO_MOTION,	//̬
	SDK_EVENT_CODE_VIDEO_LOSS,		//Ƶʧ
	SDK_EVENT_CODE_VIDEO_BLIND,		//Ƶڵ
	SDK_EVENT_CODE_STORAGE_NOT_EXIST,//洢豸
	SDK_EVENT_CODE_LOW_SPACE,		//洢豸
	SDK_EVENT_CODE_STORAGE_ERROR,//洢豸
	SDK_EVENT_CODE_NET_ERRO,		//籨
	SDK_EVENT_CODE_NR,
};



/// ϵͳʱṹ
typedef struct SDK_SYSTEM_TIME{
	int  year;///< ꡣ   
	int  month;///< £January = 1, February = 2, and so on.   
	int  day;///< ա   
	int  wday;///< ڣSunday = 0, Monday = 1, and so on   
	int  hour;///< ʱ   
	int  minute;///< ֡   
	int  second;///< 롣   
	int  isdst;///< ʱʶ   
}SDK_SYSTEM_TIME;

//Ϣ
typedef struct SDK_ALARM_INFO
{
	int nChannel;
	int iEvent;
	int iStatus;
	SDK_SYSTEM_TIME SysTime;
}SDK_AlarmInfo;

typedef struct 
{
	char mac[12];
	int  type;//android 0 iphone 1;
}PhoneInfo;
//Ϣصԭ
typedef bool (CALL_METHOD *fMessCallBack)( char *pBuf,unsigned long dwBufLen, long dwUser);

PUSH_LAYER_API int CALL_METHOD PUSH_LAYER_Init(fMessCallBack cbAlarmcallback, PhoneInfo  phoneinfo,unsigned long lUser);

PUSH_LAYER_API int CALL_METHOD PUSH_LAYER_Cleanup();
#endif
